"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// eslint-disable-next-line @typescript-eslint/no-unused-vars
const react_1 = __importStar(require("react"));
const GenericSeqPanel_1 = __importDefault(require("./GenericSeqPanel"));
const fetchTranscripts_1 = __importDefault(require("../fetchTranscripts"));
function GenericGeneSeqPanel(props) {
    const { nclistbaseurl, fastaurl, refseq, start, end, gene, urltemplate } = props;
    const [result, setResult] = (0, react_1.useState)();
    const [error, setError] = (0, react_1.useState)();
    const [transcript, setTranscript] = (0, react_1.useState)();
    const [mode, setMode] = (0, react_1.useState)("gene");
    const feature = transcript || (result === null || result === void 0 ? void 0 : result[0]);
    (0, react_1.useEffect)(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            try {
                const res = yield (0, fetchTranscripts_1.default)({
                    nclistbaseurl,
                    fastaurl,
                    refseq,
                    start,
                    end,
                    gene,
                    urltemplate,
                });
                setResult(res);
            }
            catch (e) {
                console.error(e);
                setError(e);
            }
        }))();
    }, [nclistbaseurl, fastaurl, refseq, start, end, gene, urltemplate]);
    if (error) {
        return react_1.default.createElement("div", { style: { color: "red" } }, `${error}`);
    }
    else if (!result) {
        return react_1.default.createElement("div", null, "Loading...");
    }
    else {
        return (react_1.default.createElement("div", { className: "GenericGeneSeqPanel" },
            "Transcript:",
            react_1.default.createElement("select", { onChange: e => setTranscript(result.find(r => r.id() === e.target.value)) }, result.map(r => (react_1.default.createElement("option", { key: r.id(), value: r.id() }, r.get("name"))))),
            "Mode:",
            react_1.default.createElement("select", { onChange: e => setMode(e.target.value) },
                react_1.default.createElement("option", { value: "gene" }, "gene"),
                react_1.default.createElement("option", { value: "cds" }, "CDS"),
                react_1.default.createElement("option", { value: "cdna" }, "cDNA"),
                react_1.default.createElement("option", { value: "protein" }, "protein"),
                react_1.default.createElement("option", { value: "genomic" }, "genomic"),
                react_1.default.createElement("option", { value: "genomic_sequence_updown" }, "genomic +500bp up and down stream"),
                react_1.default.createElement("option", { value: "gene_collapsed_intron" }, "gene with colapsed introns"),
                react_1.default.createElement("option", { value: "gene_updownstream" }, "gene with 500bp up and down stream"),
                react_1.default.createElement("option", { value: "gene_updownstream_collapsed_intron" }, "gene with 500bp up and down stream and colapsed introns")),
            react_1.default.createElement("br", null),
            feature ? (react_1.default.createElement(GenericSeqPanel_1.default, Object.assign({}, props, { transcript: feature, mode: mode }))) : null));
    }
}
exports.default = GenericGeneSeqPanel;
